package com.cool.store.mapper;

import com.cool.store.dto.openPreparation.UserNameDTO;
import com.cool.store.entity.EnterpriseUserDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author zhangchenbiao
 * @date 2023-06-06 02:29
 */
@Mapper
public interface EnterpriseUserMapper {
    /**
     * 获取用户信息
     * @param userId
     * @return
     */
    EnterpriseUserDO getUserInfoById(@Param("userId") String userId);

    EnterpriseUserDO getUserInfoByJobnumber(@Param("jobnumber") String jobnumber);

    EnterpriseUserDO getUserInfoByThirdOaUniqueFlag(@Param("thirdOaUniqueFlag") String thirdOaUniqueFlag);

    /**
     * 批量获取用户信息
     * @param userIdList
     * @return
     */
    List<EnterpriseUserDO> getUserInfoByUserIds( @Param("userIdList") List<String> userIdList);

    /**
     * 根据关键字搜索部门下的用户
     * @param regionIds
     * @param keyword
     * @param leaderRegionIds
     * @return
     */
    List<EnterpriseUserDO> searchUserByRegionIdsAndKeyword( @Param("regionIds") List<String> regionIds, @Param("keyword") String keyword, @Param("leaderRegionIds") List<String> leaderRegionIds);

    /**
     * 获取部门用户数
     * @param regionId
     * @return
     */
    Integer getUserCountByRegionId( @Param("regionId") String regionId);

    /**
     * 获取部门负责人用户列表
     * @param regionId
     * @return
     */
    List<EnterpriseUserDO> getUserListByDeptLeader( @Param("regionId")String regionId);

    /**
     * 根据开发经理获取用户列表
     * @param regionIds
     * @return
     */
    List<EnterpriseUserDO> getUserListByDeptLeaders( @Param("regionIds") List<String> regionIds);

    /**
     * 获取部门人员
     * @param regionIds
     * @return
     */
    List<EnterpriseUserDO> getUserListByRegionIds( @Param("regionIds") List<String> regionIds);

    EnterpriseUserDO selectByMobile( @Param("mobile") String mobile);

    EnterpriseUserDO selectByInvestmentManager( @Param("investmentManager") String investmentManager);
    /**
     * @Auther: wangshuo
     * @Date: 2024/4/24
     * @description: 根据userid查询名字
     */
    List<UserNameDTO> selectNameByUserId(@Param("userIdList") List<String> userId);

    /**
     * 获取部门人员
     * @return
     */
    List<String> getUserIdListByRegionId( @Param("regionId") Long regionId, @Param("userIdList") List<String> userId);
    /**
     * 获取部门人员
     * @return
     */
    List<EnterpriseUserDO> getUserListByRegionId( @Param("regionId") Long regionId);

}